//

int brightness;

unsigned long currentTime;

unsigned long loopTime;

const int pin_A = 3;

const int pin_B = 2;

int buttonPin = 1;

const int ledPin = 7;

unsigned char encoder_A;

unsigned char encoder_B;

unsigned char encoder_A_prev=0;

boolean lastButton = HIGH;

boolean currentButton = HIGH;

void setup(){

pinMode(ledPin, OUTPUT);

pinMode(pin_A, INPUT_PULLUP);

pinMode(pin_B, INPUT_PULLUP);

pinMode(buttonPin, INPUT_PULLUP);

currentTime = millis();

loopTime = currentTime;

}

boolean debounce(boolean last)

{

boolean current = digitalRead(buttonPin); if (last != current) { delay(5); current = digitalRead(buttonPin); } return current; }

void loop(){

currentButton = debounce(lastButton);

if (lastButton == HIGH && currentButton == LOW)

{

brightness = brightness + 255;

}

lastButton = currentButton;

if(brightness > 255) brightness = 0;

currentTime = millis();

if(currentTime >= (loopTime + 5))

{

encoder_A = digitalRead(pin_A);

encoder_B = digitalRead(pin_B);

if((!encoder_A) && (encoder_A_prev))

{

if(encoder_B)

{

if(brightness + 5 <= 255) brightness += 5;

}

else

{

if(brightness - 5 >= 0)brightness -= 5;

}

}

encoder_A_prev = encoder_A;

analogWrite(ledPin, brightness);

loopTime = currentTime;

}

}
